import { aw as t, cU as b, X as u, cV as c, P as x, bJ as k, cW as f, cX as m, Z as r, c3 as s, c4 as $, a4 as p, N as g, cY as v, aA as C, U as S, a8 as w, F as i, ad as B, af as W, Y as F, bM as I, cZ as y, bT as V } from "./765a639e.js";
import { SelectInputValidationChildren as D, useSelectInputValidate as E, selectDivRefMethods as R, SelectInputInvalidConfig as M } from "./e0072488.js";
import { formDataChildren as z } from "./445304a3.js";
import { RadioLayoutOptions as O, RadioPropertyView as T } from "./847ebdc6.js";
import "react";
import { fixOldInputCompData as A } from "./9420f36d.js";
import "react-dom";
const L = (e) => t`
    &,
    .ant-checkbox-wrapper:not(.ant-checkbox-wrapper-disabled) {
      color: ${e.staticText};
      max-width: calc(100% - 8px);

      span:not(.ant-checkbox) {
        ${b};
      }

      .ant-checkbox .ant-checkbox-checked > .ant-checkbox-inner {
        border-color: ${e.checkedBorder};
        border-width:${e.borderWidth ? e.borderWidth : "2px"};
      }

      .ant-checkbox:not(.ant-checkbox-checked) > .ant-checkbox-inner{
        border-color: ${e.uncheckedBorder};
        border-width:${e.borderWidth ? e.borderWidth : "2px"};
      }

      .ant-checkbox-checked {
        .ant-checkbox-inner {
          background-color: ${e.checkedBackground};
          border-color: ${e.checkedBorder};
          border-width:${e.borderWidth ? e.borderWidth : "2px"};

          &::after {
            border-color: ${e.checked};
          }
        }

        &::after {
          border-color: ${e.checkedBorder};
          border-width:${e.borderWidth ? e.borderWidth : "2px"};
          border-radius: ${e.radius};
        }
      }
      
      .ant-checkbox-inner {
        background-color: ${e.uncheckedBackground};
        border-radius: ${e.radius};
        border-color: ${e.checkedBorder};
        border-width:${e.borderWidth ? e.borderWidth : "2px"};
      }
    
      &:hover .ant-checkbox-inner, 
      .ant-checkbox:hover .ant-checkbox-inner,
      .ant-checkbox-input + ant-checkbox-inner {
        background-color:${e.hoverBackground ? e.hoverBackground : "#fff"};
      }

      &:hover .ant-checkbox-checked .ant-checkbox-inner, 
      .ant-checkbox:hover .ant-checkbox-inner,
      .ant-checkbox-input + ant-checkbox-inner {
        background-color:${e.hoverBackground ? e.hoverBackground : "#ffff"};
      }

      &:hover .ant-checkbox-inner,
      .ant-checkbox:hover .ant-checkbox-inner,
      .ant-checkbox-input:focus + .ant-checkbox-inner {
        border-color: ${e.checkedBorder};
        border-width:${e.borderWidth ? e.borderWidth : "2px"};
      }
    }

    

    .ant-checkbox-group-item {
      font-family:${e.fontFamily};
      font-size:${e.textSize};
      font-weight:${e.textWeight};
      font-style:${e.fontStyle};
      text-transform:${e.textTransform};
      text-decoration:${e.textDecoration};
    }
    .ant-checkbox-wrapper {
      padding: ${e.padding};
      .ant-checkbox-inner,
      .ant-checkbox-checked::after {
        border-radius: ${e.radius};
      }
    }
  `, N = u(y)`
  min-height: 32px;
  ${(e) => e.$style && L(e.$style)}
  ${(e) => {
  if (e.$layout === "horizontal")
    return t`
        display: flex;
        align-items: center;
        flex-wrap: wrap;
      `;
  if (e.$layout === "vertical")
    return t`
        display: flex;
        flex-direction: column;
      `;
  if (e.$layout === "auto_columns")
    return t`
        break-inside: avoid;
        columns: 160px;
      `;
}}
`;
let n = function() {
  const e = {
    defaultValue: c("defaultValue"),
    value: c("value"),
    label: x,
    disabled: k,
    onEvent: f,
    options: m,
    style: r(s, "style"),
    labelStyle: r($.filter((o) => ["accent", "validate"].includes(o.name) === !1), "labelStyle"),
    layout: p(O, "horizontal"),
    viewRef: g,
    inputFieldStyle: r(v, "inputFieldStyle"),
    animationStyle: r(C, "animationStyle"),
    ...D,
    ...z
  };
  return new S(e, (o, d) => {
    w(o, d);
    const [l, h] = E(o);
    return o.label({
      required: o.required,
      style: o.style,
      labelStyle: o.labelStyle,
      inputFieldStyle: o.inputFieldStyle,
      animationStyle: o.animationStyle,
      children: /* @__PURE__ */ i(N, {
        ref: o.viewRef,
        disabled: o.disabled,
        value: o.value.value,
        $style: o.inputFieldStyle,
        $layout: o.layout,
        options: o.options.filter((a) => a.value !== void 0 && !a.hidden).map((a) => ({
          label: a.label,
          value: a.value,
          disabled: a.disabled
        })),
        onChange: (a) => {
          h(a);
        }
      }),
      ...l
    });
  }).setPropertyViewFn((o) => /* @__PURE__ */ i(T, {
    ...o
  })).setExposeMethodConfigs(R).build();
}();
n = V(n, A);
const j = B(n, [new W("value", F("selectInput.valueDesc")), M, ...I]);
export {
  j as CheckboxComp,
  L as getStyle
};
