import { Y as o, X as P, bZ as F, w as Q, S as U, Z as $, b_ as q, aA as H, U as T, a8 as G, F as s, G as E, ai as I, a9 as k, aa as h, ab as S, ac as O, ad as W, af as B, ae as Z, b$ as _, c0 as X, c1 as Y } from "./765a639e.js";
import { useContext as R, useRef as d, useEffect as A } from "react";
import { EventTypeEnum as l } from "./30970d5d.js";
import "react-dom";
const z = {
  name: "{{currentUser.name}}",
  text: o("customComp.text"),
  query: "query1"
}, J = `
  <style type="text/css">
  body {
    padding: 5px;
  }
  </style>
  
  <link rel="stylesheet" type="text/css" href="https://unpkg.com/antd@4.21.4/dist/antd.min.css"/>
  <script type="text/javascript" src="https://unpkg.com/antd@4.21.4/dist/antd.min.js" ><\/script>
  
  <div id="root"></div>
  
  <script type="text/babel">
  
  const { Button, Card, Space } = antd;
  
  const MyCustomComponent = ({ runQuery, model, updateModel}) => (
    <Card title={"Hello, " + model.name}>
        <p>{model.text}</p>
        <Space>
          <Button
            type="primary"
            onClick={() => runQuery(model.query)}
         >
            ${o("customComp.triggerQuery")}
          </Button>
          <Button
            onClick={() => updateModel({ text: "${o("customComp.updateText")}" })}
          >
          ${o("customComp.updateData")}
          </Button>
      </Space>
    </Card>
  );
  
  const ConnectedComponent = ${o("customComp.sdkGlobalVarName")}.connect(MyCustomComponent);
  const root = ReactDOM.createRoot(document.getElementById("root"));
  root.render(<ConnectedComponent />);
  
  <\/script>
  `, K = P.div`
  width: 100%;
  height: 100%;
  ${(t) => t.$style};
  rotate: ${(t) => t.$style.rotation};
  ${(t) => t.$animationStyle};
  iframe {
    border: 0;
    width: 100%;
    height: 100%;
    display: block;
  }
`;
function m(t, a) {
  var n;
  (n = t == null ? void 0 : t.contentWindow) == null || n.postMessage(a, "*");
}
function tt(t) {
  const a = d(String(Date.now())), {
    model: n,
    code: c,
    onModelChange: p,
    dispatch: D
  } = t, i = d(null), r = d(n), y = d(!1), V = d({
    runQuery: async (e) => {
      const {
        queryName: u
      } = e;
      return _(D, X(u, Y({}))).catch((C) => Promise.resolve({}));
    },
    getModel: async (e) => r.current,
    updateModel: async (e) => (r.current = {
      ...r.current,
      ...e
    }, m(i.current, {
      type: l.Data,
      payload: {
        model: r.current
      }
    }), p(r.current), r.current)
  });
  return A(() => {
    m(i.current, {
      type: l.Data,
      payload: {
        model: n
      }
    }), r.current = n;
  }, [n]), A(() => {
    if (!i.current)
      return;
    const e = i.current, u = (g) => {
      const {
        type: x,
        payload: b,
        hostId: M
      } = g.data;
      if (!x || !b || !M || M !== a.current)
        return;
      const {
        method: v,
        data: j,
        id: L
      } = b;
      if (x === l.Invoke) {
        const f = V.current[v];
        if (!f || typeof f != "function")
          return;
        f(j).then((N) => {
          m(e, {
            type: l.Invoke,
            payload: {
              id: L,
              method: v,
              response: N
            }
          });
        });
      }
    }, C = () => {
      m(e, {
        type: l.Init,
        payload: {
          hostId: a.current,
          code: c
        }
      });
    };
    window.addEventListener("message", u), e.addEventListener("load", C);
    const w = e.getAttribute("src");
    if (w && y) {
      y.current = !1;
      const g = new URL("?_t=" + Date.now(), w);
      e.setAttribute("src", g.toString());
    }
    return () => {
      y.current = !0, window.removeEventListener("message", u), e.removeEventListener("load", C);
    };
  }, [c]), /* @__PURE__ */ s(K, {
    $style: t.style,
    $animationStyle: t.animationStyle,
    children: /* @__PURE__ */ s("iframe", {
      ref: i,
      title: "custom-comp",
      src: o("customComponent.entryUrl")
    })
  });
}
const et = {
  model: F(z),
  code: Q(U, J),
  style: $(q, "style"),
  animationStyle: $(H, "animationStyle")
}, ot = new T(et, (t, a) => {
  G(t, a);
  const {
    code: n,
    model: c
  } = t;
  return /* @__PURE__ */ s(tt, {
    style: t.style,
    animationStyle: t.animationStyle,
    code: n,
    model: c.value,
    onModelChange: (p) => c.onChange(p),
    dispatch: a
  });
}).setPropertyViewFn((t) => /* @__PURE__ */ s(E, {
  children: (R(I).editorModeStatus === "logic" || R(I).editorModeStatus === "both") && /* @__PURE__ */ k(E, {
    children: [/* @__PURE__ */ k(h, {
      name: S.interaction,
      children: [t.model.propertyView({
        label: o("customComp.data")
      }), t.code.propertyView({
        label: o("customComp.code"),
        language: "html"
      }), O(t)]
    }), /* @__PURE__ */ s(h, {
      name: S.style,
      children: t.style.getPropertyView()
    }), /* @__PURE__ */ s(h, {
      name: S.animationStyle,
      hasTooltip: !0,
      children: t.animationStyle.getPropertyView()
    })]
  })
})).build();
class nt extends ot {
  autoHeight() {
    return !1;
  }
}
const it = W(nt, [new B("model", o("data")), new B("code", o("code")), Z]);
export {
  it as CustomComp
};
