import { X as E, Y as t, a4 as m, P as L, w as P, S as F, eh as k, O as g, a as A, Z as p, c3 as I, c4 as M, ek as N, N as D, U as H, a8 as O, F as n, a9 as a, G as S, aa as o, ab as r, el as R, ai as u, dz as B, em as U, ad as W, af as _, en as y, av as $ } from "./765a639e.js";
import { useContext as d, useEffect as j } from "react";
import { treeCommonChildren as q, treeDataPropertyView as z, formSection as G, valuePropertyView as K, TreeNameConfigs as X, useTree as Y } from "./6346987b.js";
import { getStyle as Z, baseSelectRefMethods as J } from "./e807235b.js";
import { SelectInputValidationSection as Q, useSelectInputValidate as ee } from "./e0072488.js";
import "react-dom";
import "./445304a3.js";
import "./008323ca.js";
import "./a62a7e9b.js";
import "./3adab36e.js";
const te = E(y)`
  width: 100%;
  ${(e) => e.$style && Z(e.$style)}
`, le = [{
  label: t("tree.singleSelect"),
  value: "single"
}, {
  label: t("tree.multiSelect"),
  value: "multi"
}, {
  label: t("tree.checkbox"),
  value: "check"
}], ae = [{
  label: t("tree.showAll"),
  value: "all"
}, {
  label: t("tree.showParent"),
  value: "parent"
}, {
  label: t("tree.showChild"),
  value: "child"
}], oe = {
  ...q,
  selectType: m(le, "single"),
  checkedStrategy: m(ae, "parent"),
  label: L,
  placeholder: P(F, t("tree.placeholder")),
  // TODO: more event
  onEvent: k,
  allowClear: g,
  showSearch: g.DEFAULT_TRUE,
  inputValue: A(""),
  // search value
  style: p(I, "style"),
  labelStyle: p(M, "labelStyle"),
  inputFieldStyle: p(N, "inputFieldStyle"),
  viewRef: D
};
function re(e) {
  switch (e) {
    case "all":
      return y.SHOW_ALL;
    case "parent":
      return y.SHOW_PARENT;
    case "child":
      return y.SHOW_CHILD;
  }
}
const ne = (e) => {
  const {
    treeData: s,
    selectType: c,
    value: i,
    expanded: b,
    style: C,
    labelStyle: f,
    inputValue: V
  } = e, h = c === "single", [v, T] = ee(e);
  return j(() => {
    h && i.value.length > 1 && i.onChange(i.value.slice(0, 1));
  }, [c]), Y(e), e.label({
    required: e.required,
    ...v,
    style: C,
    labelStyle: f,
    inputFieldStyle: e.inputFieldStyle,
    children: /* @__PURE__ */ n(te, {
      ref: e.viewRef,
      $style: e.inputFieldStyle,
      popupMatchSelectWidth: !1,
      disabled: e.disabled,
      placeholder: e.placeholder,
      allowClear: e.allowClear,
      fieldNames: {
        label: "label",
        value: "value"
      },
      treeData: s,
      multiple: !h,
      value: h ? i.value[0] : i.value,
      treeCheckable: c === "check",
      showCheckedStrategy: re(e.checkedStrategy),
      treeLine: e.showLine ? {
        showLeafIcon: e.showLeafIcon
      } : !1,
      treeExpandedKeys: V ? void 0 : b.value,
      onTreeExpand: (l) => {
        b.onChange(l);
      },
      onChange: (l) => {
        const x = Array.isArray(l) ? l : l !== void 0 ? [l] : [];
        T(x);
      },
      showSearch: e.showSearch,
      treeNodeFilterProp: "label",
      autoClearSearchValue: !1,
      onSearch: (l) => {
        e.dispatch($("inputValue", l, !1));
      },
      onFocus: () => e.onEvent("focus"),
      onBlur: () => e.onEvent("blur")
    }, c)
  });
};
let w = function() {
  return new H(oe, (e, s) => (O(e, s), /* @__PURE__ */ n(ne, {
    ...e,
    dispatch: s
  }))).setPropertyViewFn((e) => /* @__PURE__ */ a(S, {
    children: [/* @__PURE__ */ a(o, {
      name: r.basic,
      children: [z(e), R(e)]
    }), ["logic", "both"].includes(d(u).editorModeStatus) && /* @__PURE__ */ a(S, {
      children: [/* @__PURE__ */ n(Q, {
        ...e
      }), G(e), /* @__PURE__ */ a(o, {
        name: r.interaction,
        children: [e.onEvent.getPropertyView(), e.hidden.propertyView({
          label: t("prop.hide")
        }), e.disabled.propertyView({
          label: t("prop.disabled")
        }), e.selectType.propertyView({
          label: t("tree.selectType")
        }), K(e), e.selectType.getView() === "check" && e.checkedStrategy.propertyView({
          label: t("tree.checkedStrategy")
        }), B(e), U(e)]
      })]
    }), ["layout", "both"].includes(d(u).editorModeStatus) && /* @__PURE__ */ a(o, {
      name: r.layout,
      children: [e.expanded.propertyView({
        label: t("tree.expanded")
      }), e.defaultExpandAll.propertyView({
        label: t("tree.defaultExpandAll")
      }), e.showLine.propertyView({
        label: t("tree.showLine")
      }), e.showLine.getView() && e.showLeafIcon.propertyView({
        label: t("tree.showLeafIcon")
      })]
    }), ["layout", "both"].includes(d(u).editorModeStatus) && e.label.getPropertyView(), ["layout", "both"].includes(d(u).editorModeStatus) && /* @__PURE__ */ a(S, {
      children: [/* @__PURE__ */ n(o, {
        name: r.style,
        children: e.style.getPropertyView()
      }), /* @__PURE__ */ n(o, {
        name: r.labelStyle,
        children: e.labelStyle.getPropertyView()
      }), /* @__PURE__ */ n(o, {
        name: r.inputFieldStyle,
        children: e.inputFieldStyle.getPropertyView()
      })]
    })]
  })).setExposeMethodConfigs(J).build();
}();
w = class extends w {
  autoHeight() {
    return !0;
  }
};
const be = W(w, [...X, new _("inputValue", t("select.inputValueDesc"))]);
export {
  be as TreeSelectComp
};
