import { X as l, du as w, Y as o, a5 as y, a3 as x, aB as $, a4 as m, dv as C, Z as s, dw as p, aA as b, U as S, a8 as v, F as a, dx as k, a9 as n, G as h, aa as i, ab as r, ai as c, ac as A, ad as V, af as T, ae as z, ah as H, aw as E, ax as F, ay as M, ao as P, aq as B, ap as W } from "./765a639e.js";
import { useContext as u } from "react";
import { MarginControl as j } from "./3adab36e.js";
import { PaddingControl as D } from "./a62a7e9b.js";
import "react-dom";
const N = [H], O = (t) => E`
    border-radius: ${t.radius ? t.radius : "4px"};
    border: ${t.borderWidth ? t.borderWidth : "0px"} ${t.borderStyle ? t.borderStyle : "solid"} ${t.border};
    color: ${t.text};
    text-transform:${t.textTransform} !important;
    text-decoration:${t.textDecoration} !important;
    background-color: ${t.background};
    .markdown-body a {
      color: ${t.links};
    }
    .markdown-body {
      margin: ${t.margin} !important;	
      padding: ${t.padding};	
      width: ${F(t.margin)};	
      font-family: ${t.fontFamily} !important;
      font-style:${t.fontStyle} !important;
      font-size: ${t.textSize} !important;
      // height: ${M(t.margin)};
      h1 {
        line-height: 1.5;
      }
      h5 {
        line-height: 2.2;
      }
    }

    .markdown-body {
      &,
      p,
      div,
      h1,
      h2,
      h3,
      h4,
      h5,
      h6 {
        color: ${t.text};
        font-weight: ${t.textWeight} !important;
      }
      img,
      pre {
        background-color: ${t.background};
        code {
          color: #000000;
        }
      }
    }
  `, R = l.div`
  height: 100%;
  overflow: auto;
  margin: 0;
  ${(t) => t.$animationStyle}
  ${(t) => t.$type === "text" && `
    white-space:break-spaces;
    line-height: 1.9;
    font-size: ${t.$styleConfig.textSize};
    font-weight: ${t.$styleConfig.textWeight};
    font-style: ${t.$styleConfig.fontStyle};
    font-family: ${t.$styleConfig.fontFamily};
    margin: ${t.$styleConfig.margin};
    padding: ${t.$styleConfig.padding};
  `};
  ${(t) => t.$styleConfig && O(t.$styleConfig)}
  display: flex;
  ${w};
  overflow-wrap: anywhere;
  .markdown-body {
    overflow-wrap: anywhere;
  }
`, U = l(P)`
  transform: rotate(90deg);
`, I = l(B)`
  transform: rotate(90deg);
`, q = l(W)`
  transform: rotate(90deg);
`, G = [{
  label: "Markdown",
  value: "markdown"
}, {
  label: o("text"),
  value: "text"
}], J = [{
  label: /* @__PURE__ */ a(U, {}),
  value: "flex-start"
}, {
  label: /* @__PURE__ */ a(q, {}),
  value: "center"
}, {
  label: /* @__PURE__ */ a(I, {}),
  value: "flex-end"
}];
let d = function() {
  const t = {
    text: y("text", o("textShow.text", {
      name: "{{currentUser.name}}"
    })),
    onEvent: x(N),
    autoHeight: $,
    type: m(G, "markdown"),
    horizontalAlignment: C(),
    verticalAlignment: m(J, "center"),
    style: s(p, "style"),
    animationStyle: s(b, "animationStyle"),
    margin: j,
    padding: D
  };
  return new S(t, (e, f) => {
    const g = e.text.value;
    return v(e, f), /* @__PURE__ */ a(R, {
      $animationStyle: e.animationStyle,
      $type: e.type,
      $styleConfig: e.style,
      style: {
        justifyContent: e.horizontalAlignment,
        alignItems: e.autoHeight ? "center" : e.verticalAlignment,
        textAlign: e.horizontalAlignment,
        rotate: e.style.rotation
      },
      onClick: () => e.onEvent("click"),
      children: e.type === "markdown" ? /* @__PURE__ */ a(k, {
        children: g
      }) : g
    });
  }).setPropertyViewFn((e) => /* @__PURE__ */ n(h, {
    children: [/* @__PURE__ */ n(i, {
      name: r.basic,
      children: [e.type.propertyView({
        label: o("value"),
        tooltip: o("textShow.valueTooltip"),
        radioButton: !0
      }), e.text.propertyView({})]
    }), ["logic", "both"].includes(u(c).editorModeStatus) && /* @__PURE__ */ n(i, {
      name: r.interaction,
      children: [A(e), e.onEvent.getPropertyView()]
    }), ["layout", "both"].includes(u(c).editorModeStatus) && /* @__PURE__ */ n(h, {
      children: [/* @__PURE__ */ n(i, {
        name: r.layout,
        children: [e.autoHeight.getPropertyView(), !e.autoHeight.getView() && e.verticalAlignment.propertyView({
          label: o("textShow.verticalAlignment"),
          radioButton: !0
        }), e.horizontalAlignment.propertyView({
          label: o("textShow.horizontalAlignment"),
          radioButton: !0
        })]
      }), /* @__PURE__ */ a(i, {
        name: r.style,
        children: e.style.getPropertyView()
      }), /* @__PURE__ */ a(i, {
        name: r.animationStyle,
        hasTooltip: !0,
        children: e.animationStyle.getPropertyView()
      })]
    })]
  })).build();
}();
d = class extends d {
  autoHeight() {
    return this.children.autoHeight.getView();
  }
};
const Q = V(d, [new T("text", o("textShow.textDesc")), z]);
export {
  Q as TextComp
};
