import { X as d, S as P, w, a3 as j, dv as N, bT as A, Z as C, d_ as F, aA as L, Y as s, U as R, F as e, G as $, a9 as r, ak as I, aa as a, ab as l, d$ as T, ai as o, ac as k, ad as B, af as M, ae as D, am as H, ah as G } from "./765a639e.js";
import { useContext as n } from "react";
import { navListComp as K } from "./e59e5853.js";
import { a as J } from "./01ae393e.js";
import "react-dom";
const X = d("div")`
${(t) => t.$animationStyle}
  height: 100%;
  border-radius: ${(t) => t.$borderRadius ? t.$borderRadius : "2px"};
  box-sizing: border-box;
  border: ${(t) => t.$borderWidth ? `${t.$borderWidth}` : "1px"} ${(t) => t.$borderStyle} ${(t) => t.$borderColor};
  background-color: ${(t) => t.$bgColor};
`, Y = d("div")`
  // margin: 0 -16px;
  height: 100%;
  display: flex;
  justify-content: ${(t) => t.$justify ? "space-between" : "left"};
`, Z = d.div`
  height: 30px;
  line-height: 30px;
  padding: ${(t) => t.$padding ? t.$padding : "0 16px"};
  color: ${(t) => t.$active ? t.$activeColor : t.$color};
  font-weight: ${(t) => t.$textWeight ? t.$textWeight : 500};
  font-family:${(t) => t.$fontFamily ? t.$fontFamily : "sans-serif"};
  font-style:${(t) => t.$fontStyle ? t.$fontStyle : "normal"};
  font-size:${(t) => t.$textSize ? t.$textSize : "14px"};
  text-transform:${(t) => t.$textTransform ? t.$textTransform : ""};
  text-decoration:${(t) => t.$textDecoration ? t.$textDecoration : ""};
  margin:${(t) => t.$margin ? t.$margin : "0px"};
  
  &:hover {
    color: ${(t) => t.$activeColor};
    cursor: pointer;
  }

  .anticon {
    margin-left: 5px;
  }
`, _ = d.div`
  cursor: pointer;
  height: 30px;
  line-height: 0;
  margin-left: 16px;

  img {
    height: 100%;
  }
`, q = d.div`
  flex: 1;
  display: flex;
  flex-direction: row;
  justify-content: ${(t) => t.$align};
`, Q = d(H)`
  &.ant-dropdown-menu {
    min-width: 160px;
  }
`, p = [G];
function tt(t) {
  return t && (t.hasOwnProperty("accentColor") || t.hasOwnProperty("backgroundColor") || t.hasOwnProperty("borderColor") || t.hasOwnProperty("color")) ? {
    text: t.color,
    accent: t.accentColor,
    background: t.backgroundColor,
    border: t.borderColor
  } : t;
}
const et = {
  logoUrl: P,
  logoEvent: w(j(p), [{
    name: "click"
  }]),
  horizontalAlignment: N(),
  style: A(C(F), tt),
  animationStyle: C(L),
  items: w(K(), [{
    label: s("menuItem") + " 1"
  }])
}, ot = new R(et, (t) => {
  const V = t.items, u = /* @__PURE__ */ e($, {
    children: V.map((z, b) => {
      const {
        hidden: E,
        label: U,
        items: g,
        active: W,
        onEvent: O
      } = z.getView();
      if (E)
        return null;
      const f = g.filter((i) => !i.children.hidden.getView()), x = [], m = [];
      f.forEach((i, y) => {
        const c = y + "";
        i.children.active.getView() && m.push(c), x.push({
          key: c,
          label: i.children.label.getView()
        });
      });
      const v = /* @__PURE__ */ r(Z, {
        $active: W || m.length > 0,
        $color: t.style.text,
        $activeColor: t.style.accent,
        $fontFamily: t.style.fontFamily,
        $fontStyle: t.style.fontStyle,
        $textWeight: t.style.textWeight,
        $textSize: t.style.textSize,
        $padding: t.style.padding,
        $textTransform: t.style.textTransform,
        $textDecoration: t.style.textDecoration,
        $margin: t.style.margin,
        onClick: () => O("click"),
        children: [U, g.length > 0 && /* @__PURE__ */ e(J, {})]
      }, b);
      if (f.length > 0) {
        const i = /* @__PURE__ */ e(Q, {
          onClick: (y) => {
            var S;
            const {
              onEvent: c
            } = (S = g[Number(y.key)]) == null ? void 0 : S.getView();
            c("click");
          },
          selectedKeys: m,
          items: x
        });
        return /* @__PURE__ */ e(I, {
          dropdownRender: () => i,
          children: v
        }, b);
      }
      return v;
    })
  }), h = t.horizontalAlignment === "justify";
  return /* @__PURE__ */ e(X, {
    $borderStyle: t.style.borderStyle,
    $animationStyle: t.animationStyle,
    $borderColor: t.style.border,
    $bgColor: t.style.background,
    $borderWidth: t.style.borderWidth,
    $borderRadius: t.style.radius,
    children: /* @__PURE__ */ r(Y, {
      $justify: h,
      children: [t.logoUrl && /* @__PURE__ */ e(_, {
        onClick: () => t.logoEvent("click"),
        children: /* @__PURE__ */ e("img", {
          src: t.logoUrl,
          alt: "LOGO"
        })
      }), h ? u : /* @__PURE__ */ e(q, {
        $align: t.horizontalAlignment,
        children: u
      })]
    })
  });
}).setPropertyViewFn((t) => /* @__PURE__ */ r($, {
  children: [/* @__PURE__ */ e(a, {
    name: l.basic,
    children: T(t.items)
  }), (n(o).editorModeStatus === "logic" || n(o).editorModeStatus === "both") && /* @__PURE__ */ e(a, {
    name: l.interaction,
    children: k(t)
  }), (n(o).editorModeStatus === "layout" || n(o).editorModeStatus === "both") && /* @__PURE__ */ r(a, {
    name: l.layout,
    children: [t.horizontalAlignment.propertyView({
      label: s("navigation.horizontalAlignment"),
      radioButton: !0
    }), k(t)]
  }), (n(o).editorModeStatus === "logic" || n(o).editorModeStatus === "both") && /* @__PURE__ */ r(a, {
    name: l.advanced,
    children: [t.logoUrl.propertyView({
      label: s("navigation.logoURL"),
      tooltip: s("navigation.logoURLDesc")
    }), t.logoUrl.getView() && t.logoEvent.propertyView({
      inline: !0
    })]
  }), (n(o).editorModeStatus === "layout" || n(o).editorModeStatus === "both") && /* @__PURE__ */ r($, {
    children: [/* @__PURE__ */ e(a, {
      name: l.style,
      children: t.style.getPropertyView()
    }), /* @__PURE__ */ e(a, {
      name: l.animationStyle,
      hasTooltip: !0,
      children: t.animationStyle.getPropertyView()
    })]
  })]
})).build(), st = B(ot, [new M("logoUrl", s("navigation.logoURLDesc")), D, new M("items", s("navigation.itemsDesc"))]);
export {
  st as NavComp
};
